/**
 * The MIT License (MIT)
 * Copyright (c) 2012-present 铭软科技(mingsoft.net)
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:

 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.

 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */




package net.mingsoft.cms.biz;

import net.mingsoft.base.biz.IBaseBiz;
import net.mingsoft.cms.entity.CategoryEntity;

import java.util.List;


/**
 * 分类业务
 * @author 铭飞开发团队
 * 创建日期：2019-11-28 15:12:32<br/>
 * 历史修订：<br/>
 */
public interface ICategoryBiz extends IBaseBiz<CategoryEntity> {

    /**
     * 查询当前分类下的所有子分类,包含自身
     * @param category 通过setId指定栏目id
     * @return
     */
    List<CategoryEntity> queryChildren(CategoryEntity category);

    void saveEntity(CategoryEntity entity);

    /**更新父级及子集
     * @param entity
     */
    void updateEntity(CategoryEntity entity);

    /**只更新自身
     * @param entity
     */
    void update(CategoryEntity entity);

    void delete(String categoryId);

    void copyCategory(CategoryEntity entity);

    /**
     * 强转栏目类型
     * @param categoryEntity 栏目实体
     * @param targetCategoryType 目标栏目类型
     */
    void changeCategoryType(CategoryEntity categoryEntity,String targetCategoryType);
}
