SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for mdiy_tag
-- ----------------------------
DROP TABLE IF EXISTS `mdiy_tag`;
CREATE TABLE `mdiy_tag` (
                            `id` int(11) NOT NULL AUTO_INCREMENT,
                            `tag_name` varchar(255) DEFAULT NULL COMMENT '标签名称',
                            `tag_type` varchar(255) DEFAULT NULL COMMENT '标签类型',
                            `tag_sql` text COMMENT '标签sql',
                            `tag_class` varchar(255) DEFAULT NULL COMMENT '标签类',
                            `tag_description` varchar(255) DEFAULT NULL COMMENT '描述',
                            `UPDATE_BY` varchar(11) DEFAULT NULL COMMENT '更新人',
                            `UPDATE_DATE` datetime DEFAULT NULL COMMENT '更新时间',
                            `CREATE_BY` varchar(11) DEFAULT NULL COMMENT '创建人',
                            `CREATE_DATE` datetime DEFAULT NULL COMMENT '创建时间',
                            `DEL` int(1) DEFAULT '0' COMMENT '删除标记',
                            `NOT_DEL` int(1) DEFAULT '0' COMMENT '1为不能删除，主要用于系统默认数据,0为一般数据，主要是前端控制',
                            PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='标签';

-- ----------------------------
-- Records of mdiy_tag
-- ----------------------------
BEGIN;
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (3, 'arclist', 'list', '<#assign _typeid=\'\'/>\n<#assign _typetitle=\'\'/>\n<#-- 分页数，默认返回20条数据 -->\n<#assign _size=\'20\'/>\n<#if column?? && column.id?? && column.id?number gt 0>\n  <#assign  _typeid=\'${column.id}\'>\n</#if>\n<#if typeid??>\n  <#assign  _typeid=\'${typeid}\'>\n</#if>\n<#if typetitle??>\n  <#assign  _typetitle=\'${typetitle}\'>\n</#if>\n<#if size??>\n  <#assign  _size=\'${size}\'>\n</#if>\n\n<#if orderby?? >\n  <#if orderby==\'date\'>\n    <#assign  _orderby=\'content_datetime\'>\n  <#elseif orderby==\'updatedate\'>\n    <#assign  _orderby=\'cms_content.update_date\'>\n  <#elseif orderby==\'hit\'>\n    <#assign  _orderby=\'content_hit\'>\n  <#elseif orderby==\'sort\'>\n    <#assign  _orderby=\'content_sort\'>\n  <#else>\n    <#assign  _orderby=\'cms_content.content_datetime\'>\n  </#if>\n<#else>\n    <#assign  _orderby=\'cms_content.content_datetime\'>\n</#if>\n\nSELECT\n  cms_content.id AS \"id\",\n  content_title AS \"title\",\n  content_short_title AS \"shorttitle\",\n  content_author AS \"author\",\n  content_source AS \"source\",\n  content_out_link AS \"outlink\",\n  content_tags AS \"tags\",\n\n  category.category_title AS \"typetitle\",\n  category.category_short_title AS \"typeshorttitle\",\n  category.id AS \"typeid\",\n  category.category_path AS \"typepath\",\n  category.category_img AS \"typelitpic\",\n  category.category_ico AS \"typeico\",\n  category.category_keyword as \"typekeyword\",\n  category.top_id as \"topid\",\n  category.category_id as \"parentid\",\n  category.category_parent_ids as \"parentids\",\n  category.category_type AS \"type\",\n  <#--列表页动态链接-->\n  <#if isDo?? && isDo>\n    CONCAT(\'${modelName}/list.do?style=${templateName!\"\"}&typeid=\', category.category_id) as \"typelink\",\n  <#else>\n  <#--栏目类型为链接-->\n    <#if shortSwitch?? && shortSwitch>\n      CONCAT(category.category_pinyin,\'.html\') AS \"typelink\",\n    <#else>\n      CONCAT(category.category_path,\'/index.html\') AS \"typelink\",\n    </#if>\n  </#if>\n  content_description AS \"descrip\",\n  content_hit AS \"hit\",\n  content_type AS \"flag\",\n  cms_content.content_keyword AS \"keyword\",\n  content_img AS \"litpic\",\n  <#--内容页动态链接-->\n  <#if isDo?? && isDo>\n    CONCAT(\'${modelName}/view.do?style=${templateName!\"\"}&id=\', cms_content.id) as \"link\",\n  <#else>\n    <#if shortSwitch?? && shortSwitch>\n      CONCAT(cms_content.id,\'.html\') AS \"link\",\n    <#else>\n      CONCAT(CONCAT( category.category_path, \'/\' ), CONCAT(CASE category_type WHEN  \'2\' THEN \'index\' ELSE cms_content.id END , \'.html\' )) as \"link\",\n    </#if>\n  </#if>\n  <#if tableName??>${tableName}.*,</#if>\n  content_datetime AS \"date\"\nFROM\n  cms_content\nLEFT JOIN\n  cms_category as category\nON cms_content.category_id = category.id\n<#--判断是否有自定义模型表-->\n<#if tableName??>\n  LEFT JOIN ${tableName} ON ${tableName}.link_id=cms_content.id\n</#if>\nWHERE\n  content_display=0\n  and category_display=\'enable\'\n  and cms_content.del=0\n\n<#--文章审核-->\n<#if contentApprove?? && contentApprove>\n  and cms_content.progress_status=\'终审通过\'\n</#if>\n<#--根据站点编号查询-->\n<#if appId?? >\n  and cms_content.app_id=${appId}\n  and cms_content.id>0\n</#if>\n<#--判断是否有搜索分类集合，暂时移除 _typeid=\"\" 条件-->\n<#if search?? && !typeid??>\n  and category_is_search=\'enable\'\n  <#-- 文章标签 -->\n  <#if search.content_tag??>and FIND_IN_SET(\'${search.content_tag}\',content_tags) > 0</#if>\n  <#if search.categoryIds?has_content>\n  and (\n    <#list search.categoryIds?split(\",\") as item>\n    <#if item?index gt 0>\n   or\n    </#if>\n    (cms_content.category_id=${item}\n   or cms_content.category_id in (select id FROM cms_category where cms_category.del=0\n    <#if _typetitle?has_content>\n  and cms_category.category_title=\'${_typetitle}\'\n    </#if>\n  and FIND_IN_SET(${item},CATEGORY_PARENT_IDS) > 0)\n    )\n    </#list>\n    )\n  </#if>\n  <#--标题-->\n  <#if search.content_title??> and content_title like CONCAT(CONCAT(\'%\',\'${search.content_title}\'),\'%\')</#if>\n  <#--作者-->\n  <#if search.content_author??> and content_author like CONCAT(CONCAT(\'%\',\'${search.content_author}\'),\'%\')</#if>\n  <#--来源-->\n  <#if search.content_source??> and content_source like CONCAT(CONCAT(\'%\',\'${search.content_source}\'),\'%\')</#if>\n  <#--属性-->\n  <#if search.content_type??>\n    and(<#list search.content_type?split(\',\') as item>\n    <#if item?index gt 0> or</#if>\n      FIND_IN_SET(\'${item}\',cms_content.content_type) > 0\n    </#list>)\n  </#if>\n  <#--描述-->\n  <#if search.content_description??>\n    and content_description like CONCAT(CONCAT(\'%\',\'${search.content_description}\'),\'%\')\n  </#if>\n  <#--关键字-->\n  <#if search.content_keyword??> and content_keyword like CONCAT(CONCAT(\'%\',\'${search.content_keyword}\'),\'%\')</#if>\n  <#--内容-->\n  <#if search.content_details??> and content_details like CONCAT(CONCAT(\'%\',\'${search.content_details}\'),\'%\')</#if>\n  <#--自定义顺序-->\n  <#if search.content_sort??> and content_sort=${search.content_sort}</#if>\n  <#--时间范围-->\n  <#if search.content_datetime_start??&&search.content_datetime_end??>\n    and content_datetime between \'${search.content_datetime_start}\' and \'${search.content_datetime_end}\'\n  </#if>\n<#else>\n  <#--查询栏目-->\n  <#if _typeid?has_content && _typeid?string != \'0\'>\n  and (cms_content.category_id=${_typeid}\n  or cms_content.category_id in (select id FROM cms_category where cms_category.del=0\n    <#if _typetitle?has_content>\n      and cms_category.category_title=\'${_typetitle}\'\n    </#if>\n  and FIND_IN_SET(${_typeid},CATEGORY_PARENT_IDS) > 0))\n  <#elseif typeids?has_content>\n  and (\n    <#list typeids?split(\",\") as item>\n      <#if item?index gt 0>\n        or\n      </#if>\n  (cms_content.category_id=${item}\n   or cms_content.category_id in (select id FROM cms_category where cms_category.del=0\n    <#if _typetitle?has_content>\n  and cms_category.category_title=\'${_typetitle}\'\n    </#if>\n  and FIND_IN_SET(${item},CATEGORY_PARENT_IDS) > 0)\n    )\n    </#list>\n    )\n  </#if>\n</#if>\n<#--判断搜索分类结束-->\n<#--标题-->\n<#if content_title??> and content_title like CONCAT(CONCAT(\'%\',\'${content_title}\'),\'%\')</#if>\n<#--作者-->\n<#if content_author??> and content_author like CONCAT(CONCAT(\'%\',\'${content_author}\'),\'%\')</#if>\n<#--来源-->\n<#if content_source??> and content_source like CONCAT(CONCAT(\'%\',\'${content_source}\'),\'%\')</#if>\n<#--属性-->\n<#if content_type??> and content_type like CONCAT(CONCAT(\'%\',\'${content_type}\'),\'%\')</#if>\n<#--描述-->\n<#if content_description??> and content_description like CONCAT(CONCAT(\'%\',\'${content_description}\'),\'%\')</#if>\n<#--关键字-->\n<#if content_keyword??> and content_keyword like CONCAT(CONCAT(\'%\',\'${content_keyword}\'),\'%\')</#if>\n<#--内容-->\n<#if content_details??> and content_details like CONCAT(CONCAT(\'%\',\'${content_details}\'),\'%\')</#if>\n<#--自定义顺序-->\n<#if content_sort??> and content_sort=${content_sort}</#if>\n<#--自定义模型-->\n<#if diyModel??>\n  <#list diyModel as dm>\n  <#assign json=\"${dm}\"?eval />\n    and ${tableName}.${json.key} like CONCAT(CONCAT(\'%\',\'${json.value}\'),\'%\')\n  </#list>\n</#if>\n<#--文章属性-->\n<#if flag?? >\n  and(<#list flag?split(\',\') as item>\n  <#if item?index gt 0> or</#if>\n  FIND_IN_SET(\'${item}\',cms_content.content_type) > 0\n  </#list>)\n</#if>\n<#if noflag??>\n  and(<#list noflag?split(\',\') as item>\n  <#if item?index gt 0> and</#if>\n  FIND_IN_SET(\'${item}\',cms_content.content_type)=0\n  </#list> or cms_content.content_type is null)\n</#if>\n\n  <#--字段排序-->\n    ORDER BY\n      <#if topflag??>\n        CASE\n        <#list topflag?split(\",\") as item>\n            WHEN FIND_IN_SET(\'${item}\',cms_content.content_type)>0 THEN\n            ${item?index}\n        </#list>\n        ELSE 100\n        END,\n      </#if>\n      ${_orderby}\n  <#if order?? >\n    <#if order==\'desc\'> desc</#if>\n    <#if order==\'asc\'> asc</#if>\n  <#else>\n    desc\n  </#if>\n  LIMIT\n  <#--判断是否分页-->\n  <#if ispaging?? && (pageTag.pageNo)??>\n    ${((pageTag.pageNo-1)*_size?eval)?c},${_size?default(20)}\n  <#else>\n    ${_size?default(20)}\n  </#if>\n\n', NULL, '文章列表', NULL, NULL, NULL, NULL, 0, 1);
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (4, 'channel', 'list', '<#assign _typeid=\'0\'/>\n<#assign _size=\'9999\'/>\n<#if column?? && column.id?? && column.id?number gt 0>\n  <#assign  _typeid=\'${column.id}\'>\n  <#assign  selfid=\'${column.id}\'>\n</#if>\n\n<#if typeid??>\n  <#assign  _typeid=\'${typeid}\'>\n</#if>\n<#if size??>\n  <#assign  _size=\'${size}\'>\n</#if>\n\nselect\n  cms_category.id as \"id\",\n  cms_category.id as \"typeid\",\n  cms_category.category_title as \"typetitle\",\n  cms_category.category_short_title as \"typeshorttitle\",\n  <#--动态链接-->\n  <#if isDo?? && isDo>\n    IF(cms_category.category_type=2,CONCAT(\'${modelName}/view.do?style=${templateName!\"\"}&typeid=\', cms_category.id),CONCAT(\'${modelName}/list.do?style=${templateName!\"\"}&typeid=\', cms_category.id)) as \"typelink\",\n  <#else>\n    <#--栏目类型为链接-->\n    <#if shortSwitch?? && shortSwitch>\n      CONCAT(cms_category.category_pinyin,\'.html\') AS \"typelink\",\n    <#else>\n      CONCAT(cms_category.category_path,\'/index.html\') as \"typelink\",\n    </#if>\n  </#if>\n  cms_category.category_keyword as \"typekeyword\",\n  cms_category.category_diy_url as \"typeurl\",\n  cms_category.category_flag as \"flag\",\n  cms_category.category_id as \"parentid\",\n  cms_category.category_parent_ids as \"parentids\",\n  cms_category.category_descrip as \"typedescrip\",\n  cms_category.category_type as \"type\",\n  cms_category.category_path as \"typepath\",\n  cms_category.leaf as \"typeleaf\",\n  cms_category.category_img as \"typelitpic\" ,\n  cms_category.category_ico as \"typeico\" ,\n  <#if tableName??>${tableName}.*,</#if>\n  ( SELECT count(*) FROM cms_category cc WHERE cc.category_id = cms_category.id AND cc.del = 0 ) AS \"childsize\"\nfrom\n  cms_category\n  <#--判断是否有自定义模型表-->\n  <#if tableName??>LEFT JOIN ${tableName} ON ${tableName}.link_id=cms_category.id</#if>\nwhere\n  cms_category.del=0\n  and  cms_category.category_display = \'enable\'\n  <#--自定义模型-->\n  <#if diyModel??>\n    <#list diyModel as dm>\n    <#assign json=\"${dm}\"?eval />\n    and ${tableName}.${json.key} like CONCAT(\'%\',\'${json.value}\',\'%\')\n    </#list>\n  </#if>\n  <#--根据站点编号查询-->\n  <#if appId?? >\n    and cms_category.app_id=${appId}\n  </#if>\n\n  <#--栏目属性-->\n  <#if flag?? >\n    and\n      (<#list flag?split(\',\') as item>\n      <#if item?index gt 0> or</#if>\n      FIND_IN_SET(\'${item}\',cms_category.category_flag) > 0\n      </#list>)\n  </#if>\n\n  <#if noflag?? >\n    and\n      (<#list noflag?split(\',\') as item>\n      <#if item?index gt 0> and</#if>\n      FIND_IN_SET(\'${item}\',cms_category.category_flag)=0\n      </#list> or cms_category.category_flag is null)\n  </#if>\n\n  <#--type默认son-->\n  <#if !type??||!type?has_content>\n    <#assign type=\'son\'/>\n  </#if>\n\n  <#if type?has_content>\n    <#--顶级栏目（单个）-->\n    <#if type==\'top\'>\n      <#if _typeid != \'0\'>\n        and (cms_category.id = cms_category.top_id or cms_category.top_id = 0)\n      </#if>\n\n    <#elseif type==\'nav\'>\n      and(cms_category.category_id=0 or cms_category.category_id is null)\n\n    <#--同级栏目（多个）-->\n    <#elseif type==\'level\'>\n      <#if _typeid != \'0\'>\n        and cms_category.category_id=(select category_id from cms_category where id=${_typeid})\n      </#if>\n\n    <#--当前栏目（单个）-->\n    <#elseif type==\'self\'>\n      <#if _typeid != \'0\'>\n        and cms_category.id=${_typeid}\n      </#if>\n\n    <#--当前栏目的所属栏目（多个）-->\n    <#elseif type==\'path\'>\n      <#if _typeid != \'0\'>\n        and cms_category.id in\n        (<#if column?? && column.categoryParentIds??>${column.categoryParentIds},</#if>${_typeid})\n      </#if>\n\n    <#--子栏目（多个）-->\n    <#elseif type==\'son\'>\n      <#if _typeid != \'0\'>\n        and cms_category.category_id=${_typeid}\n      </#if>\n\n    <#--上一级栏目没有则取当前栏目（单个）-->\n    <#elseif type==\'parent\'>\n      <#if _typeid != \'0\'>\n        and\n          <#if column?? && column.categoryId??>\n            cms_category.id=${column.categoryId}\n          <#else>\n            cms_category.id=${_typeid}\n          </#if>\n      </#if>\n    </#if>\n\n  <#else> <#--默认顶级栏目-->\n    and\n      <#if _typeid != \'0\'>\n        cms_category.id=${_typeid}\n      <#else>\n        (cms_category.category_id=0 or cms_category.category_id is null)\n      </#if>\n  </#if>\n\n   <#--字段排序-->\n  <#if type == \'path\'>\n    ORDER BY cms_category.category_path asc\n  <#else>\n    <#if orderby?? >\n      ORDER BY\n        <#if orderby==\'date\'> cms_category.create_date\n        <#elseif orderby==\'sort\'> cms_category.category_sort\n        <#else>cms_category.id\n        </#if>\n    </#if>\n\n    <#if order?? >\n      <#if order==\'desc\'> desc</#if>\n      <#if order==\'asc\'> asc</#if>\n    </#if>\n  </#if>\n  LIMIT\n    ${_size?default(9999)}\n', NULL, '通用栏目', NULL, NULL, NULL, NULL, 0, 1);
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (5, 'global', 'single', 'select\n  APP_NAME as \"name\",\n  app_logo as \"logo\",\n  app_keyword as \"keyword\",\n  app_description as \"descrip\",\n  app_copyright as \"copyright\",\n  \'${contextPath}\' as \"contextpath\",\n  <#--动态解析 -->\n  <#if isDo?? && isDo>\n    \'${url}\' as \"url\",\n    \'${url}\' as \"host\",\n    \'/\' as \"html\",\n  <#--使用地址栏的域名 -->\n  <#else>\n    <#if shortSwitch?? && shortSwitch>\n      CONCAT(\'${url}\',\'${appDir}<#if appDir?has_content>/</#if>\') as \"url\",\n      \'<#if appDir?has_content>/</#if>${appDir}/\' as \"html\",\n    <#else>\n      CONCAT(CONCAT(\'${url}\',\'${html}\'),\'<#if appDir?has_content>/${appDir}</#if>\') as \"url\",\n      CONCAT(CONCAT(\'/${html}\',\'<#if appDir?has_content>/${appDir}</#if>\'),\'/\') as \"html\",\n    </#if>\n    \'${url}\' as \"host\",\n  </#if>\n    CONCAT(CONCAT(CONCAT(CONCAT(\'template/\',id),\'/\'),app_style),\'/\') as \"style\"\nfrom app\n  <#--根据站点编号查询-->\n  <#if appId?? >\n    where id = ${appId}\n  </#if>', NULL, '全局', NULL, NULL, NULL, NULL, 0, 1);
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (7, 'field', 'single', 'SELECT\n    cms_content.id as \"id\",\n    <#--这里会存在id覆盖的情况,所以需要在cms_content.id下面-->\n    <#if tableName??>${tableName}.*,</#if>\n    <#--查询站点编号-->\n    <#if appId??>\n        cms_content.app_id as \"appId\",\n    </#if>\n    content_title as \"title\",\n    content_short_title AS \"shorttitle\",\n    content_author as \"author\",\n    content_source as \"source\",\n    content_out_link as \"outlink\",\n    content_details as \"content\",\n    content_datetime as \"date\",\n    content_description as \"descrip\",\n    content_keyword as \"keyword\",\n    <#if contextPath?? && contextPath != \"/\">\n    	CONCAT(CONCAT( \'<script type=\"text/javascript\" src=\"${contextPath}/cms/content/\', cms_content.id),\'/hit.do\"></script>\') as \"hit\",\n    <#else>\n    	CONCAT(CONCAT( \'<script type=\"text/javascript\" src=\"/cms/content/\', cms_content.id),\'/hit.do\"></script>\') as \"hit\",\n    </#if>\n    content_type as \"flag\",\n    content_tags as \"tags\",\n    category_title as \"typetitle\",\n    cms_content.content_img as \"litpic\",\n    <#--内容页动态链接-->\n    <#if isDo?? && isDo>\n    	CONCAT(\'/mcms/view.do?id=\', cms_content.id) as \"link\",\n    <#else>\n    	<#if shortSwitch?? && shortSwitch>\n    		CONCAT(cms_content.id, \'.html\' ) as \"link\",\n    	<#else>\n    		CONCAT(CONCAT( cms_category.category_path, \'/\' ), CONCAT(cms_content.id, \'.html\' )) as \"link\",\n    	</#if>\n    </#if>\n    cms_category.id as \"typeid\",\n    cms_category.leaf as \"typeleaf\",\n    cms_category.category_title as \"typetitle\",\n    cms_category.category_short_title AS \"typeshorttitle\",\n    cms_category.category_img as \"typelitpic\",\n    cms_category.category_ico as \"typeico\",\n    cms_category.category_path as \"typepath\",\n    cms_category.top_id as \"topid\",\n    cms_category.category_flag as \"typeflag\",\n    cms_category.category_id as \"parentid\",\n    cms_category.category_parent_ids as \"parentids\",\n    cms_category.category_keyword as \"typekeyword\",\n    cms_category.category_descrip as \"typedescrip\",\n    <#--动态链接-->\n    <#if isDo?? && isDo>\n    	CONCAT(\'/${modelName}/list.do?typeid=\', cms_category.id) as \"typelink\"\n    <#else>\n    	<#if shortSwitch?? && shortSwitch>\n    		CONCAT(category_pinyin,\'.html\') AS \"typelink\"\n    	<#else>\n    		CONCAT(category_path,\'/index.html\') AS \"typelink\"\n    	</#if>\n    </#if>\n\nFROM cms_content\n    LEFT JOIN cms_category  ON\n    cms_category.id = cms_content.category_id\n    <#--判断是否有自定义模型表-->\n    <#if tableName??>left join ${tableName} on ${tableName}.link_id=cms_content.id</#if>\nWHERE\n    <#--如果是栏目列表页没有文章id所以只取栏目id-->\n    <#if column??&&column.id??&&!id??>\n        cms_category.id=${column.id} and\n    </#if>\n    <#--根据站点编号查询-->\n    <#if appId??>\n        cms_content.app_id = ${appId} and\n    </#if>\n    cms_content.del=0\n    <#if id??> and cms_content.id=${id}</#if>\n\n', NULL, '文章内容', NULL, NULL, NULL, NULL, 0, 1);
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (8, 'pre', 'single', '<#assign select=\"\'\'\"/>\n<#if orderby?? >\n	<#if orderby==\"date\">\n	  <#assign  _orderby=\"content_datetime\">\n	<#elseif orderby==\"updatedate\">\n	  <#assign  _orderby=\"cms_content.update_date\">\n	<#elseif orderby==\"hit\">\n	  <#assign  _orderby=\"content_hit\">\n	<#elseif orderby==\"sort\">\n	  <#assign  _orderby=\"content_sort\">\n	<#else><#assign  _orderby=\"cms_content.id\"></#if>\n<#else>\n	<#assign  _orderby=\"cms_content.id\">\n</#if>\n<#--上一页-->\n<#if pageTag.preId??>\n	SELECT\n    cms_content.id as \"id\",\n    content_title as \"title\",\n    content_author as \"author\",\n    content_source as \"source\",\n    content_details as \"content\",\n    category.category_title as \"typename\",\n    category.category_id as \"typeid\",\n    <#if isDo?? && isDo>\n      CONCAT(\'/${modelName}/list.do?typeid=\', cms_category.id) as \"typelink\",\n    <#else>\n    	<#if shortSwitch?? && shortSwitch>\n            CONCAT(category.category_pinyin,\'.html\') AS \"typelink\",\n    	<#else>\n    		CONCAT(category.category_path,\'/index.html\') AS \"typelink\",\n    	</#if>\n    </#if>\n    content_img as \"litpic\",\n    <#--内容页动态链接-->\n    <#if isDo?? && isDo>\n    	CONCAT(\'${modelName}/view.do?id=\', cms_content.id,\'&orderby=${_orderby}\',\'&order=${order!\'ASC\'}\',\'&typeid=${typeid}\') as \"link\",\n    <#else>\n      <#if shortSwitch?? && shortSwitch>\n        CONCAT(cms_content.id,\'.html\') AS \"link\",\n      <#else>\n    	CONCAT(CONCAT(category_path,\'/\'),CONCAT(cms_content.id,\'.html\')) AS \"link\",\n      </#if>\n    </#if>\n    content_description as \"descrip\",\n    content_hit as \"hit\",\n    content_type as \"flag\",\n    content_keyword as \"keyword\"\n	FROM cms_content\n    LEFT JOIN cms_category category ON cms_content.category_id=category.id\n	WHERE cms_content.id=${pageTag.preId}\n<#else>\n	SELECT\n    ${select} as \"id\",\n    \'没有了\' as \"title\",\n    ${select} as \"author\",\n    ${select} as \"source\",\n    ${select} as \"content\",\n    ${select} as \"typename\",\n    ${select} as \"typeid\",\n    ${select} as \"typelink\",\n    ${select} as \"litpic\",\n    ${select} as \"typelink\",\n    ${select} as \"date\",\n    ${select} as \"descrip\",\n    ${select} as \"hit\",\n    ${select} as \"flag\",\n    ${select} as \"keyword\"\n    FROM dual\n</#if>\n', NULL, '文章上一篇', NULL, NULL, NULL, NULL, 0, 1);
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (9, 'page', 'single', '<#if pageTag??>\nselect\n  <#--是否开启短链接-->\n    <#if shortSwitch?? && shortSwitch>\n	    \'${shortSwitch?string(\'true\',\'false\')}\' as \"shortSwitch\",\n    </#if>\n	<#if !(pageTag.indexUrl??)>\n		<#--判断是否有栏目对象，用于搜索不传栏目-->\n		<#if column??>\n			<#if shortSwitch?? && shortSwitch>\n				<#assign path=column.categoryPinyin/>\n			<#else>\n				<#assign path=column.categoryPath/>\n			</#if>\n		<#else>\n			<#assign path=\'\' />\n		</#if>\n		<#--总记录数、总页数-->\n		\'${pageTag.total}\' as \"total\",\n		\'${pageTag.size}\' as \"size\",\n\n		<#--记录总数-->\n		\'${pageTag.rcount}\' as \"rcount\",\n		<#--当前页码-->\n		\'${pageTag.pageNo}\' as \"cur\",\n		<#--首页-->\n		<#if shortSwitch?? && shortSwitch>\n			CONCAT(\'${path}\', \'.html\') as \"index\",\n		<#else>\n			CONCAT(\'${path}\', \'/index.html\') as \"index\",\n		</#if>\n		<#--上一页-->\n		<#if (pageTag.pageNo?eval-1) gt 1>\n			<#if shortSwitch?? && shortSwitch>\n				CONCAT(\'${path}\',\'-${pageTag.pageNo?eval-1}.html\') as \"pre\",\n			<#else>\n				CONCAT(\'${path}\',\'/list-${pageTag.pageNo?eval-1}.html\') as \"pre\",\n			</#if>\n		<#else>\n			<#if shortSwitch?? && shortSwitch>\n				CONCAT(\'${path}\',\'.html\') as \"pre\",\n			<#else>\n				CONCAT(\'${path}\',\'/index.html\') as \"pre\",\n			</#if>\n		</#if>\n		<#--下一页-->\n		<#if pageTag.total lte 1>\n			<#if shortSwitch?? && shortSwitch>\n				CONCAT(\'${path}\', \'.html\') as \"next\",\n				CONCAT(\'${path}\', \'.html\') as \"last\"\n			<#else>\n				CONCAT(\'${path}\', \'/index.html\') as \"next\",\n				CONCAT(\'${path}\', \'/index.html\') as \"last\"\n			</#if>\n		<#else>\n			<#if pageTag.pageNo?eval gte pageTag.total>\n				<#if shortSwitch?? && shortSwitch>\n					CONCAT(\'${path}\',\'-${pageTag.total}.html\') as \"next\",\n				<#else>\n					CONCAT(\'${path}\',\'/list-${pageTag.total}.html\') as \"next\",\n				</#if>\n			<#else>\n				<#if shortSwitch?? && shortSwitch>\n					CONCAT(\'${path}\',\'-${pageTag.pageNo?eval+1}.html\') as \"next\",\n				<#else>\n					CONCAT(\'${path}\',\'/list-${pageTag.pageNo?eval+1}.html\') as \"next\",\n				</#if>\n			</#if>\n			<#--最后一页-->\n			<#if shortSwitch?? && shortSwitch>\n				CONCAT(\'${path}\',\'-${pageTag.total}.html\') as \"last\"\n			<#else>\n				CONCAT(\'${path}\',\'/list-${pageTag.total}.html\') as \"last\"\n			</#if>\n		</#if>\n	<#else>\n		<#--判断是否是搜索页面-->\n		\'${pageTag.indexUrl}\' as \"index\",\n		\'${pageTag.lastUrl}\' as \"last\",\n		\'${pageTag.preUrl}\' as \"pre\",\n		\'${pageTag.nextUrl}\' as \"next\",\n		\'${pageTag.total}\' as \"total\",\n		\'${pageTag.size}\' as \"size\",\n		\'${pageTag.rcount}\' as \"rcount\",\n		\'${pageTag.pageNo}\' as \"cur\"\n	</#if>\n    from dual\n</#if>', NULL, '通用分页', NULL, NULL, NULL, NULL, 0, 1);
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (10, 'next', 'single', '<#assign select=\"\'\'\"/>\n<#if orderby?? >\n	<#if orderby==\"date\">\n		<#assign  _orderby=\"content_datetime\">\n	<#elseif orderby==\"updatedate\">\n		<#assign  _orderby=\"cms_content.update_date\">\n	<#elseif orderby==\"hit\">\n		<#assign  _orderby=\"content_hit\">\n	<#elseif orderby==\"sort\">\n		<#assign  _orderby=\"content_sort\">\n	<#else>\n		<#assign  _orderby=\"cms_content.id\"></#if>\n	<#else>\n		<#assign  _orderby=\"cms_content.id\">\n	</#if>\n<#--开始-->\n<#if pageTag.nextId??>\n	SELECT\n    cms_content.id as \"id\",\n    content_title as \"title\",\n    content_author as \"author\",\n    content_source as \"source\",\n    content_details as \"content\",\n    category.category_title as \"typename\",\n    category.category_id as \"typeid\",\n    <#if isDo?? && isDo>\n        CONCAT(\'/${modelName}/list.do?typeid=\', cms_category.id) as \"typelink\",\n    <#else>\n        <#if shortSwitch?? && shortSwitch>\n            CONCAT(category.category_pinyin,\'.html\') AS \"typelink\",\n        <#else>\n            CONCAT(category.category_path,\'/index.html\') AS \"typelink\",\n        </#if>\n    </#if>\n    content_img as \"litpic\",\n    <#--内容页动态链接-->\n    <#if isDo?? && isDo>\n        CONCAT(\'${modelName}/view.do?id=\', cms_content.id,\'&orderby=${_orderby}\',\'&order=${order!\'ASC\'}\',\'&typeid=${typeid}\') as \"link\",\n    <#else>\n        <#if shortSwitch?? && shortSwitch>\n            CONCAT(cms_content.id,\'.html\') AS \"link\",\n        <#else>\n            CONCAT(CONCAT(category_path,\'/\'),CONCAT(cms_content.id,\'.html\')) AS \"link\",\n        </#if>\n    </#if>\n    content_description as \"descrip\",\n    content_hit as \"hit\",\n    content_type as \"flag\",\n    content_keyword as \"keyword\"\n	FROM cms_content\n    LEFT JOIN cms_category category ON cms_content.category_id=category.id\n	WHERE cms_content.id=${pageTag.nextId}\n<#else>\n  SELECT\n    ${select} as \"id\",\n    \'没有了\' as \"title\",\n    ${select} as \"author\",\n    ${select} as \"source\",\n    ${select} as \"content\",\n    ${select} as \"typename\",\n    ${select} as \"typeid\",\n    ${select} as \"typelink\",\n    ${select} as \"litpic\",\n    ${select} as \"link\",\n    ${select} as \"date\",\n    ${select} as \"descrip\",\n    ${select} as \"hit\",\n    ${select} as \"flag\",\n    ${select} as \"keyword\"\n  FROM dual\n</#if>\n', NULL, '文章下一篇', NULL, NULL, NULL, NULL, 0, 1);
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (11, 'diyform', 'macro', '<#macro ms_diyform formName>\n<div id=\"form\" v-cloak style=\"width: 30%; margin: 5% auto\">\n  <div id=\"formModel\">\n    <!--会自动渲染代码生成器的表单-->\n  </div>\n  <!--必须包含验证码-->\n  <el-form ref=\"form\" :model=\"form\" :rules=\"rules\" label-position=\"right\" size=\"large\" label-width=\"120px\">\n    <el-row :gutter=\"0\" justify=\"start\" align=\"top\">\n      <el-col :span=\"12\">\n        <el-form-item label=\"验证码\" prop=\"rand_code\">\n          <el-input\n                  v-model=\"form.rand_code\"\n                  :disabled=\"false\"\n                  :readonly=\"false\"\n                  :clearable=\"true\"\n                  placeholder=\"请输入验证码\">\n          </el-input>\n        </el-form-item>\n      </el-col>\n      <el-col :span=\"12\">\n        <div style=\"display: flex; height: 38px;margin-left: 1em; align-items: center; cursor: pointer\">\n          <img :src=\"verifCode\" class=\"code-img\" @click=\"code\"/>\n          <div @click=\"code\" style=\"margin-left: 10px\">\n            看不清？换一张\n          </div>\n        </div>\n      </el-col>\n    </el-row>\n    <el-form-item label=\"  \">\n      <el-button @click=\"save\" type=\"primary\" :loading=\"isLoading\" style=\"width: 200px\">\n        {{isLoading ? \'保存中\' : \'保存\'}}\n      </el-button>\n    </el-form-item>\n  </el-form>\n</div>\n<script>\n  //vue的实例名称必须为 from\n  var form = new Vue({\n    el: \'#form\',\n    data: {\n      formModel: undefined, //自定义业务的vue对象\n      verifCode:  \"/code.do?t=\" + new Date().getTime(),\n      isLoading: false,\n      form: {\n        rand_code: \'\'\n      },\n      rules: {\n        rand_code: [\n          {required: true, message: \'请输入验证码\', trigger: \'blur\'},\n          {min: 1, max: 4, message: \'长度不能超过4个字符\', trigger: \'change\'}\n        ],\n      },\n    },\n    methods: {\n      save: function () {\n        var that = this;\n        that.isLoading = true;\n        //将验证码值复制到自定义模型\n        form.formModel.form.rand_code = this.form.rand_code;\n        //调用自定义模型的保存\n        that.formModel.save(function (res) {\n          if (res.result) {\n            that.$notify({\n              title: \'成功\',\n              type: \'success\',\n              message: \'保存成功!\'\n            });\n\n          } else {\n            that.$notify({\n              title: \'失败\',\n              message: res.msg,\n              type: \'warning\'\n            });\n          }\n          that.isLoading = false;\n        });\n      },\n      code: function () {\n        this.verifCode = \"/code.do?t=\" + (new Date).getTime();\n      }\n    },\n    created: function () {\n      var that = this;\n      ms.mdiy.model.form(\"formModel\", { \"modelName\": \"${formName}\" }).then(function(obj) {\n        that.formModel = obj;\n      });\n    }\n  });\n</script>\n</#macro>', NULL, '智能表单', '57', '2022-11-15 16:10:49', NULL, NULL, 0, 1);
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (12, 'data', 'list', 'SELECT\n	cms_content.id AS \"id\",\n	content_title AS \"title\",\n	content_author AS \"author\",\n	content_source AS \"source\",\n	content_details AS \"content\",\n	content_out_link AS \"outlink\",\n	content_short_title AS \"shorttitle\",\n	category.category_title AS \"typetitle\",\n	category.category_short_title AS \"typeshorttitle\",\n	category.id AS \"typeid\",\n	category.category_path AS \"typepath\",\n	category.category_img AS \"typelitpic\",\n	category.category_ico AS \"typeico\",\n	category.category_keyword AS \"typekeyword\",\n	category.top_id AS \"topid\",\n	category.category_parent_ids AS \"parentids\",\n	category.category_type AS \"type\",\n	<#--列表页动态链接-->\n	<#if isDo?? && isDo>\n	    CONCAT(\'/${modelName}/list.do?style=${templateName!\"\"}&typeid=\', category.category_id) AS \"typelink\",\n	<#else>\n	<#if shortSwitch?? && shortSwitch>\n		CONCAT(category_pinyin,\'.html\') AS \"typelink\",\n	<#else>\n		CONCAT(category_path,\'/index.html\') AS \"typelink\",\n	</#if>\n	</#if>\n	content_description AS \"descrip\",\n	content_hit AS \"hit\",\n	content_type AS \"flag\",\n	cms_content.content_keyword AS \"keyword\",\n	content_img AS \"litpic\",\n	<#--内容页动态链接-->\n	<#if isDo?? && isDo>\n		CONCAT(\'/${modelName}/view.do?style=${templateName!\"\"}&id=\', cms_content.id) AS \"link\",\n	<#else>\n		<#if shortSwitch?? && shortSwitch>\n			CONCAT(cms_content.id,\'.html\') AS \"link\",\n		<#else>\n			CONCAT(CONCAT(CONCAT(category.category_path,\'/\'),cms_content.id),\'.html\') AS \"link\",\n		</#if>\n	</#if>\n 	<#if tableName??>${tableName}.*,</#if>\n	content_datetime AS \"date\"\nFROM\n	cms_content LEFT JOIN cms_category category ON cms_content.category_id = category.id\n	<#--判断是否有自定义模型表-->\n	<#if tableName??>\n		LEFT JOIN ${tableName} ON ${tableName}.link_id=cms_content.id\n	</#if>\nWHERE\n  content_display=0\n  and category_display=\'enable\'\n  and cms_content.del=0\n	<#--根据站点编号查询-->\n	<#if appId?? >\n		and cms_content.app_id=${appId}\n	</#if>\n	and cms_content.id=${dataid}\n\n', NULL, '单篇', '57', '2022-11-15 16:10:49', NULL, NULL, 0, 1);
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (17, 'tag', 'single', '<#assign _typeid=\'0\'/>\n<#assign order=\'desc\'/>\n<#assign _size=\'99\'/>\n<#if column?? && column.id?? && column.id?number gt 0>\n  <#assign  _typeid=\'${column.id}\'>\n</#if>\n\n<#if typeid??>\n  <#assign  _typeid=\'${typeid}\'>\n</#if>\n<#if size??>\n  <#assign  _size=\'${size}\'>\n</#if>\n\nSELECT\n    GROUP_CONCAT(DISTINCT content_tags ) AS tags\nFROM\n    cms_content\nLEFT JOIN cms_category ON cms_content.category_id = cms_category.id\nWHERE\n  cms_category.category_display = \'enable\'\n  AND cms_content.del = 0\n  AND cms_content.content_display = 0\n  AND LENGTH( cms_content.content_tags )>0\n    <#if _typeid != \'0\'>\n      AND (cms_category.id = ${_typeid} or FIND_IN_SET(${_typeid},cms_category.category_parent_ids) > 0)\n    </#if>\n    <#if appId??>\n  AND cms_content.app_id = ${appId}\n    </#if>\nORDER BY CONTENT_HIT DESC\nLimit ${_size}\n', '', '文章标签配置，不提供模板使用', '', '2023-06-12 17:26:19', '57', '2023-05-23 09:31:49', 57, 1);
INSERT INTO `mdiy_tag` (`id`, `tag_name`, `tag_type`, `tag_sql`, `tag_class`, `tag_description`, `UPDATE_BY`, `UPDATE_DATE`, `CREATE_BY`, `CREATE_DATE`, `DEL`, `NOT_DEL`) VALUES (18, 'tags', 'macro', '<#assign tags=\"\">\n<#macro ms_tags>\n    <#if tag??>\n        <#assign ___tags = tag.tags?split(\",\")>\n		<#list ___tags as tag>\n		    <#list ___tags as _tag>\n		        <#if tag == _tag>\n		            <#if tag_index == _tag_index>\n		            	<#assign tags+=tag+\",\">\n		            <#else>\n		            <#break>\n		            </#if>\n		        </#if>\n		    </#list>\n		</#list>\n    </#if>\n</#macro>', '', '文章标签', '', '2023-06-12 17:26:21', '57', '2023-05-23 09:31:40', 57, 1);
COMMIT;

ALTER TABLE `mdiy_model` ADD COLUMN `model_id_type` int(1) NULL COMMENT '0雪花1自增长' AFTER `model_name`;
SET FOREIGN_KEY_CHECKS = 1;
